Bug 755709 - Review Request: python-phacter - a system facts tool
Review Request: python-phacter - a system facts tool
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Lutterkort
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-11-21 15:30 EST by Dan Radez
Modified: 2013-10-19 10:42 EDT (History)
5 users (show)

See Also:
Fixed In Version: python-phacter-0.2.0-2.fc16
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-11-30 15:42:27 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
lutter: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Dan Radez 2011-11-21 15:30:44 EST
Spec URL: http://fedorapeople.org/~radez/python-phacter.spec
SRPM URL: http://fedorapeople.org/~radez/python-phacter-0.2.0-1.fc16.src.rpm
Description: 
This is a python version of ruby's facter.
My team is working on pushing a different package to fedora that we're going to have depend on this on.

phacter is a simple interface to get information frem a system
Comment 1 John Eckersberg 2011-11-22 15:05:51 EST
Initial review, although this requires an official sponsor, and I am not one.

[FAIL] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

$ rpmlint python-phacter-0.2.0-1.fc16.src.rpm 
python-phacter.src: W: invalid-url Source0: python-phacter-0.2.0.tar.gz
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

^^^ Source0 should contain full URL to source, see http://fedoraproject.org/wiki/Packaging/SourceURL#Referencing_Source

$ rpmlint python-phacter-0.2.0-1.fc16.noarch.rpm 
python-phacter.noarch: E: incorrect-fsf-address /usr/bin/phacter
python-phacter.noarch: E: incorrect-fsf-address /usr/lib/python2.7/site-packages/phacter/darwin.py
python-phacter.noarch: E: incorrect-fsf-address /usr/lib/python2.7/site-packages/phacter/utils/linux.py
python-phacter.noarch: E: incorrect-fsf-address /usr/lib/python2.7/site-packages/phacter/linux.py
python-phacter.noarch: E: incorrect-fsf-address /usr/lib/python2.7/site-packages/phacter/windows.py
python-phacter.noarch: E: incorrect-fsf-address /usr/lib/python2.7/site-packages/phacter/utils/__init__.py
python-phacter.noarch: E: incorrect-fsf-address /usr/lib/python2.7/site-packages/phacter/__init__.py
python-phacter.noarch: W: no-manual-page-for-binary phacter
1 packages and 0 specfiles checked; 7 errors, 1 warnings.

^^^ upstream source should correct the mailing address for FSF in GPL headers

[PASS] MUST: The package must be named according to the Package Naming Guidelines.

[PASS] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

[PASS] MUST: The package must meet the Packaging Guidelines.

[PASS] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.

[PASS] MUST: The License field in the package spec file must match the actual license.

[PASS] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

[PASS] MUST: The spec file must be written in American English.

[PASS] MUST: The spec file for the package MUST be legible.

[FAIL] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

[PASS] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.

[PASS] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.

[PASS] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

[N/A] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[N/A] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

[PASS] MUST: Packages must NOT bundle copies of system libraries.

[N/A] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.

[PASS] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

[PASS] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)

[PASS] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.

[FAIL] MUST: Each package must consistently use macros.

%{_usr}/bin should instead use %{_bindir}
%{_var}/lib should instead use %{_sharedstatedir}

[PASS] MUST: The package must contain code, or permissable content.

[PASS] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).

[PASS] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.

[N/A] MUST: Header files must be in a -devel package.

[N/A] MUST: Static libraries must be in a -static package.

[N/A] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.

[N/A] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}

[N/A] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

[N/A] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

[PASS] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.

[PASS] MUST: All filenames in rpm packages must be valid UTF-8.

[PASS] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.

[FAIL] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.

[PASS] SHOULD: The reviewer should test that the package builds in mock.

[PASS] SHOULD: The package should compile and build into binary rpms on all supported architectures.

[FAIL] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.

The package should probably require redhat-lsb, otherwise the following occurs:

$ phacter
...
kernelversion => 3.1.1
sh: lsb_release: command not found
lsbdistcodename => 
sh: lsb_release: command not found
lsbdistdescription => 
sh: lsb_release: command not found
lsbdistid => 
sh: lsb_release: command not found
lsbdistrelease => 
sh: lsb_release: command not found
lsbmajdistrelease => 
sh: lsb_release: command not found
lsbrelease => 
manufacturer => None
sh: lsb_release: command not found
operatingsystem => 
sh: lsb_release: command not found
operatingsystemrelease => 
permid => 
processorcount => 4
...

[N/A] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.

[N/A] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.

[N/A] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.

[N/A] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

[FAIL] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.
Comment 2 Dan Radez 2011-11-28 13:02:16 EST
Uploaded new files to fedorapeople:
python-phacter-0.2.0-2.fc16.noarch.rpm    
python-phacter-0.2.0-2.fc16.src.rpm
python-phacter-0.2.0.tar.gz
python-phacter.spec

> [FAIL] MUST: rpmlint must be run on the source rpm and all binary rpms the
> build produces. The output should be posted in the review.
> 

$ rpmlint dist/rpms/python-phacter-0.2.0-2.fc16.src.rpm dist/rpms/noarch/python-phacter-0.2.0-2.fc16.noarch.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.


> [FAIL] MUST: The sources used to build the package must match the upstream
> source, as provided in the spec URL. Reviewers should use md5sum for this task.
> If no upstream URL can be specified for this package, please see the Source URL
> Guidelines for how to deal with this.
> 

uploaded the source and updated the spec

> [FAIL] MUST: Each package must consistently use macros.
> 
> %{_usr}/bin should instead use %{_bindir}
> %{_var}/lib should instead use %{_sharedstatedir}
>

Updated spec

> [FAIL] SHOULD: The description and summary sections in the package spec file
> should contain translations for supported Non-English languages, if available.
>

Need a little help / still working on this. Not cone across the solution yet
 
> [FAIL] SHOULD: The reviewer should test that the package functions as
> described. A package should not segfault instead of running, for example.
> 

This has been fixed. Didn't want to add a hard dep, Added code to check for what's needed.

> [FAIL] SHOULD: your package should contain man pages for binaries/scripts. If
> it doesn't, work with upstream to add them where they make sense.

Added
Comment 3 James Laska 2011-11-29 10:56:03 EST
Confirming changes made in comment#2

> [PASS] MUST: rpmlint must be run on the source rpm and all binary rpms the
> build produces. The output should be posted in the review.

# rpmlint python-phacter* /var/lib/mock/fedora-16-x86_64/result/python-phacter-0.2.0-2.fc16.noarch.rpm 
2 packages and 1 specfiles checked; 0 errors, 0 warnings.

> [PASS] MUST: The sources used to build the package must match the upstream
> source, as provided in the spec URL. Reviewers should use md5sum for this task.
> If no upstream URL can be specified for this package, please see the Source URL
> Guidelines for how to deal with this.

# md5sum python-phacter*tar.gz*
7799b5aea5e3b7aa9f51b951a9e5c221  python-phacter-0.2.0.tar.gz (in src.rpm)
7799b5aea5e3b7aa9f51b951a9e5c221  python-phacter-0.2.0.tar.gz (upstream)

> [PASS] MUST: Each package must consistently use macros.

> [FAIL] SHOULD: The description and summary sections in the package spec file
> should contain translations for supported Non-English languages, if available.
>
> Need a little help / still working on this. Not cone across the solution yet

This is a *SHOULD* requirement and shouldn't block the review.

> [PASS] SHOULD: The reviewer should test that the package functions as
> described. A package should not segfault instead of running, for example.

Running phacter on a system without redhat-lsb installed works fine now.

> [PASS] SHOULD: your package should contain man pages for binaries/scripts. If
> it doesn't, work with upstream to add them where they make sense.

$ man phacter # works great

All other MUST requirements listed at https://fedoraproject.org/wiki/Packaging:ReviewGuidelines are satisfied. 
All MUST requirements listed at https://fedoraproject.org/wiki/Packaging:Python are satisfied.

The only suggestion I might have is to avoid using wildcards in the %files section.  For example, I'd be concerned that the line "%{python_sitelib}/*" might easily pull in other unintended files/directories.  I'd probably break that out into a more explicit...

%{python_sitelib}/phacter
%{python_sitelib}/python_phacter-%{version}*.egg-info


While I am not a sponsor, but I would approve this review at this point.  We'll need to find someone to sponsor you and approve this request.
Comment 4 David Lutterkort 2011-11-30 13:09:35 EST
APPROVED

Please follow
http://fedoraproject.org/wiki/Package_SCM_admin_requests#New_Packages and
import the package. Close this bug as RAWHIDE once it's been successfully
imported and built.
Comment 5 Dan Radez 2011-11-30 14:37:11 EST
New Package SCM Request
=======================
Package Name: python-phacter
Short Description: a python system fact gathering tool
Owners: radez
Branches: f15 f16 el6
InitialCC:
Comment 6 Jon Ciesla 2011-11-30 15:03:37 EST
Git done (by process-git-requests).
Comment 7 Fedora Update System 2011-11-30 15:41:08 EST
python-phacter-0.2.0-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/python-phacter-0.2.0-2.fc16
Comment 8 Fedora Update System 2012-01-21 16:51:18 EST
python-phacter-0.2.0-2.fc16 has been pushed to the Fedora 16 stable repository.

Note You need to log in before you can comment on or make changes to this bug.